var widgets;

widgets = new Object();
widgets.objs = new Object();
widgets.objcount = 0;
widgets.basepath = "file://$RESOURCES/glyphs/";

function slider_click(obj,slider,n)
{
	var i;
	if(slider.selected != null) {
		slider.selected.src = slider.off[slider.current]
	}
	for(i=0;i<slider.steps;i++) {
		if(i < n) {
			document["_obj_" + (i + slider.base)].src = slider.on[i];
		} else {
			document["_obj_" + (i + slider.base)].src = slider.off[i];
		}
	}
	obj.src = slider.on[n];
	slider.current = n;
	slider.selected = obj;
	document[slider.action](n);
}

function slider_adjust(slider, adj)
{
	var n;
	n = slider.current + adj;
	if(n < 0) return;
	if(n >= slider.steps) return;
	slider_click(document["_obj_" + (n + slider.base)], slider, n);
}

function widgets_slider(name, steps, action)
{
	var s,i,bn;

	s = new Object();
	s.steps = steps;
	s.off = new Array(steps);
	s.on = new Array(steps);
	s.current = 0;
	s.action = action;
	widgets.objs[name] = s;

	bn = widgets.basepath;

	s.base = widgets.objcount;

	s.on[0] = bn + "endcapleft_active.gif";
	s.off[0] = bn + "endcapleft_inactive.gif";
	for(i = 1; i < (steps - 1); i++){
		s.on[i] = bn + "bar_active.gif";
		s.off[i] = bn + "bar_inactive.gif";
	}
	s.on[steps-1] = bn + "endcapright_active.gif";
	s.off[steps-1] = bn + "endcapright_inactive.gif";

//	document.write('<IMG onMouseOver=\'this.src="'+bn+'left_active.gif";\' onMouseOut=\'this.src="'+bn+'left.gif";\' onClick="slider_adjust(widgets.objs.'+name+',-1);" SRC="'+bn+'left.gif">');
	for(i = 0; i < steps; i++) {
		document.write('<IMG NAME="_obj_'+widgets.objcount+'" onClick="slider_click(this,widgets.objs.'+name+','+i+')" SRC="'+s.off[i]+'">');
		widgets.objcount++;		
 	}
//	document.write('<IMG onMouseOver=\'this.src="'+bn+'right_active.gif";\' onMouseOut=\'this.src="'+bn+'right.gif";\' onClick="slider_adjust(widgets.objs.'+name+',1);" SRC="'+bn+'right.gif">');
}


function widgets_radio_group(name)
{
	var r,i;
	r = new Object();
	r.base = widgets.objcount;
	widgets.objs[name] = r;

	for(i = 1; arguments[i]; i++) {
		document.write('<IMG ALIGN=CENTER NAME="_obj_'+widgets.objcount+'" SRC="'+widgets.basepath+'radio_inactive.gif">');
		document.write(arguments[i] + "<BR>");
		widgets.objcount++;
	}
}

function checkbox_adjust(obj, enabled)
{
	var img = document["_obj_"+obj.base];
	if(enabled) {
		obj.enabled = true;
		img.src = obj.on;
	} else {
		obj.enabled = false;
		img.src = obj.off;
	}		
	document[obj.action](enabled);
}

function checkbox_toggle(name)
{
	var obj = widgets.objs[name];	
	if(obj.enabled) {
		checkbox_adjust(obj, false);	
	} else {
		checkbox_adjust(obj, true);
	}
}

function widgets_checkbox(name,action)
{
	var c;
	c = new Object();
	c.base = widgets.objcount;
	c.action = action;
	c.off = widgets.basepath + "checkbox_inactive.gif";
	c.on = widgets.basepath + "checkbox_active.gif";
	c.enabled = false;
	widgets.objs[name] = c;
	widgets.objcount++;
	document.write('<IMG ALIGN=CENTER onClick="checkbox_toggle(\''+name+'\');" NAME="_obj_'+c.base+'" SRC="'+c.off+'">');
}

function widgets_calendar()
{
	var x,y,c;

	document.write('<TABLE>');
	document.write('<TR><TD VALIGN=CENTER ALIGN=CENTER COLSPAN=7><IMG SRC="../glyphs/left.gif" onClick="calendar_year(-1);">&nbsp;<IMG NAME="ci_y0" SRC="../glyphs/2.gif" WIDTH=24 HEIGHT=32><IMG NAME="ci_y1" SRC="../glyphs/0.gif" WIDTH=24 HEIGHT=32><IMG NAME="ci_y2" SRC="../glyphs/0.gif" WIDTH=24 HEIGHT=32><IMG NAME="ci_y3" SRC="../glyphs/0.gif" WIDTH=24 HEIGHT=32>&nbsp;<IMG SRC="../glyphs/right.gif" onClick="calendar_year(1);"></TD></TR>');
	document.write('<TR><TD COLSPAN=7> <BR></TD></TR>')
	document.write('<TR><TD VALIGN=TOP ALIGN=CENTER COLSPAN=7><IMG SRC="../glyphs/left.gif" onClick="calendar_month(-1);">&nbsp;<IMG NAME="ci_month" SRC="../Months/0.gif">&nbsp;<IMG SRC="../glyphs/right.gif" onClick="calendar_month(1);"></TD></TD>');
	document.write('<TR><TD COLSPAN=7> <BR></TD></TR>')
	document.write('<TR><TD><IMG SRC="../Days/0.gif"></TD><TD><IMG SRC="../Days/1.gif"></TD><TD><IMG SRC="../Days/2.gif"></TD><TD><IMG SRC="../Days/3.gif"></TD><TD><IMG SRC="../Days/4.gif"></TD><TD><IMG SRC="../Days/5.gif"></TD><TD><IMG SRC="../Days/6.gif"></TD></TR>');
	c = 0;
	for(y = 0; y < 6; y++){
		document.write('<TR>');
		for(x = 0; x < 7; x++){
			document.write('<TD WIDTH=36 HEIGHT=24 ALIGN=CENTER><IMG NAME="ci_a'+c+'" SRC="'+widgets.basepath+'blank.gif" onClick="click_calendar('+c+');"><IMG NAME="ci_b'+c+'" SRC="'+widgets.basepath+'blank.gif" onClick="click_calendar('+c+');"></TD>');
			c++;
		}
		document.write('</TR>');
	}
	document.write('<TR><TD COLSPAN=7> <BR></TD></TR>')
	document.write('<TR><TD COLSPAN=7> <BR></TD></TR>')
	document.write('</TABLE>');
	document.write('<TABLE>');
	document.write('<TR><TD><IMG NAME="ci_h0" SRC="../glyphs/0.gif"><IMG NAME="ci_h1" SRC="../glyphs/0.gif"></TD><TD><IMG SRC="../Time/colon.gif"></TD><TD><IMG NAME="ci_m0" SRC="../glyphs/0.gif"><IMG NAME="ci_m1" SRC="../glyphs/0.gif"></TD><TD>&nbsp;<IMG NAME="ci_ap" SRC="../Time/am.gif"></TD></TR>')
	document.write('<TR><TD><IMG SRC="../glyphs/left.gif" onClick="calendar_hour(-1);><IMG SRC="../glyphs/right.gif" onClick="calendar_hour(1);></TD><TD>&nbsp;</TD><TD><IMG SRC="../glyphs/left.gif" onClick="calendar_minute(-1);><IMG SRC="../glyphs/right.gif" onClick="calendar_minute(1);></TD><TD>&nbsp;</TD></TR>');
	document.write('</TABLE>');
	document.calendar = new Object();
	document.calendar.time_changed = 0;
	document.calendar.date_changed = 0;
}

function save_calendar()
{
	beos.dprintf("save calendar");
	if(document.calendar.time_changed){
		document.calendar.time_changed = 0;
		beos.sendMessageSync("application/x-vnd.Be-TellBrowser", "tbTD",
							"hour", "float", document.calendar.date.getHours(),
							"minute", "float", document.calendar.date.getMinutes());
	}
	if(document.calendar.date_changed){
		document.calendar.date_changed = 0;
		beos.sendMessageSync("application/x-vnd.Be-TellBrowser", "tbTD",
							"year", "float", document.calendar.date.getFullYear(),
							"month", "float", document.calendar.date.getMonth(),
							"day", "float", document.calendar.date.getDate());
	}
}

function click_calendar(c)
{
	if(c < document.calendar.first_day) return;
	if(c > document.calendar.last_day) return;

	document.calendar.date_changed = 1;
	document.calendar.now_day = c;
	document.calendar.date.setDate(c - document.calendar.first_day + 1);
	refresh_calendar();
}

function refresh_calendar()
{
	var cal,c,a,b,x;
	cal = document.calendar;

	document.ci_month.src = "file://$RESOURCES/Months/"+document.calendar.date.getMonth()+".gif";

	n = document.calendar.date.getFullYear();
	document.ci_y0.src = widgets.basepath + Math.floor(n / 1000) + ".gif";
	document.ci_y1.src = widgets.basepath + Math.floor((n / 100) % 10) + ".gif";
	document.ci_y2.src = widgets.basepath + Math.floor((n / 10) % 10) + ".gif";
	document.ci_y3.src = widgets.basepath + Math.floor(n % 10) + ".gif";

	n = document.calendar.date.getHours();
	if(n < 12) {
		document.ci_ap.src = "../Time/am.gif";
		if(n == 0) n = 12;
	} else {
		document.ci_ap.src = "../Time/pm.gif";
		if(n > 12) n -= 12;
	}
	if(n < 10) {
		document.ci_h0.src = widgets.basepath + "blank.gif";
	} else {
		document.ci_h0.src = widgets.basepath + Math.floor(n / 10) + ".gif";
	}
	document.ci_h1.src = widgets.basepath + Math.floor(n % 10) + ".gif";

	n = document.calendar.date.getMinutes();
	document.ci_m0.src = widgets.basepath + Math.floor(n / 10) + ".gif";
	document.ci_m1.src = widgets.basepath + Math.floor(n % 10) + ".gif";
	n = 1;

	document.calendar.now_day = document.calendar.date.getDate();
	for(c=0;c<42;c++){
		if((c < cal.first_day) || (c > cal.last_day)){
			document["ci_a"+c].src = widgets.basepath+"blank.gif";
			document["ci_b"+c].src = widgets.basepath+"blank.gif";
		} else {
			a = Math.floor(n / 10);
			b = Math.floor(n % 10);
			if(n == cal.now_day) {
				x = "x.gif";
			} else {
				x = ".gif";
			}
			if(n < 10){
				document["ci_a"+c].src = widgets.basepath+"blank"+x;
			} else {
				document["ci_a"+c].src = widgets.basepath+a+x;
			}
			document["ci_b"+c].src = widgets.basepath+b+x;			
			n++;
		}
	}
}

function set_calendar(d)
{
	var i;
	
	document.calendar.date = new Date(d.getTime());
	document.calendar.now_day = d.getDate();
	d.setDate(1);
	document.calendar.first_day = d.getDay();
	for(i=28;i<32;i++){
		d.setDate(i);
		if(d.getDate() != i) break;
	}
	document.calendar.last_day = document.calendar.first_day + i - 2;
	calendar_timer();
}

function calendar_year(adjust)
{
	document.calendar.date_changed = 1;
	document.calendar.date.setDate(1);
	document.calendar.date.setFullYear(document.calendar.date.getFullYear() + adjust);
	set_calendar(document.calendar.date);
	refresh_calendar();
}

function calendar_month(adjust)
{
	document.calendar.date_changed = 1;
	document.calendar.date.setDate(1);
	document.calendar.date.setMonth(document.calendar.date.getMonth() + adjust);
	set_calendar(document.calendar.date);
	refresh_calendar();
}

function calendar_hour(adjust)
{
	document.calendar.time_changed = 1;
	document.calendar.date.setHours(document.calendar.date.getHours() + adjust);
	set_calendar(document.calendar.date);
	refresh_calendar();
}

function calendar_minute(adjust)
{
	document.calendar.time_changed = 1;
	document.calendar.date.setMinutes(document.calendar.date.getMinutes() + adjust);
	set_calendar(document.calendar.date);
	refresh_calendar();
}


function calendar_timer() 
{
	var d;
	if(document.calendar.time_changed == 1) return;

//	top.beos.dprintf("tick");
	d = new Date();
	if(d.getMinutes() != document.calendar.date.getMinutes()) {
		document.calendar.date.setMinutes(d.getMinutes());
		document.calendar.date.setHours(d.getHours());
		set_calendar(document.calendar.date);
		refresh_calendar();
	}
	setTimeout("calendar_timer();", 10000);
}

